export const colorLegend = (selection, props) => {
  const { 
    colorScale,
  	circleRadius,
    circleDistance,
    textOffset
  } = props;
  
  const groups = selection.selectAll('g')
  	.data(colorScale.domain());  
  
  const groupsEnter = groups
  .enter().append('g')
    .attr('class', 'tick');
  groupsEnter
    .merge(groups) // merge is also for updating
  		.attr('transform', (d,i) => 
        `translate(0, ${i * circleDistance})`
      )
  
  groups.exit().remove();
  
  groupsEnter.append('circle')
  		.attr('r', circleRadius)
  	.merge(groups.select('circle'))
      .attr('fill', colorScale);
  
  groupsEnter.append('text')
      .attr('x', textOffset)
  		.attr('dy', '0.32em') //this magic value centers perfectly
  	.merge(groups.select('text'))
      .text(d => d);
};
